10 ' Grid Analysis, Ketchum, 1984
20 DEFINT I-N
30 CLS:PRINT:CLEAR 120
40 PRINT "GRID  ANALYSIS":PRINT
50 RESTORE 3000
60 READ B$:PRINT "PROBLEM IDENTIFICATION: ";
70 PRINT B$:PRINT
80 READ M2,JF,EL
90 DIM W(M2),MJ(M2,2),NC(JF,3),CJ(JF,2),A(M2,2),AL(M2)
100 DIM AT(20,2),ND(JR,2)
110 FOR I=1 TO JF:NC(I,1)=1:NC(I,2)=1:NC(I,3)=1:NEXT
120 PRINT "NUMBER OF MEMBERS     = " ;M2
130 PRINT "NUMBER OF JOINTS      = ";JF
140 PRINT "MODULUS OF ELASTICITY = ";EL
150 '
160 '  Main Program
170 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
180 GOSUB 1040 ' Joint coordinates
190 GOSUB 450  '  Member properties, incidences
200 GOSUB 680  '  Band width
210 PRINT:PRINT "ASSEMBLE MATRIX"
220 FOR M1=1 TO M2
230 GOSUB 1130 ' Dimensions
240 GOSUB 2130 '  Stiffness
250 GOSUB 2390 '  Assembly
260 NEXT M1: PRINT
270 GOSUB 2520 '  Solve matrix
280 GOSUB 1200 '  Loads
290 GOSUB 2680 '  Second part of solver
300 GOSUB 1750 '  Deflections
310 PRINT: PRINT "MEMBER FORCES":PRINT
320 FOR M1=1 TO M2
330 GOSUB 1130 '  Dimensions
340 GOSUB 2130 '  Stiffness
350 GOSUB 1850 '  Forces
360 NEXT M1
370 GOSUB 2050 '  Statics check
380 ON ERROR GOTO 400  
390 GOTO 280  
400  PRINT "NO LOAD DATA STATEMENTS"
410 INPUT "DATA MAY BE FAULTY, OTHERWISE <ENTER> TO START AGAIN ";ZZ
420 RESUME 20
430 END
440 '
450 PRINT "MEMBER PROPERTIES":PRINT "MEMBER      I           T"
460 READ I:IF I=0 THEN 500  
470 READ AT(I,1),AT(I,2)
480 PRINT USING "###   ####.####   ####.####";I,AT(I,1),AT(I,2)
490 GOTO 460  
500 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
510 PRINT:PRINT "MEMBER INCIDENCES AND TYPES"
520 PRINT "MEMBER     JT.  TO  JT.      TYPE"
530 FOR I=1 TO M2:READ IT,II,JJ,JT:MJ(I,1)=II:MJ(I,2)=JJ
540 PRINT USING " ###     "; I;II;JJ;JT
550 A(I,1)=AT(JT,1):A(I,2)=AT(JT,2):NEXT
560 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
570 PRINT " "
580 PRINT "SUPPORTS AND RELEASES"
590 PRINT "MEMBER     Z   P(X)  P(Y)"
600 READ I:IF I=0 THEN 650  
610 READ K1,K2,K3
620 PRINT USING "######";I,K1,K2,K3
630 NC(I,1)=K1:NC(I,2)=K2:NC(I,3)=K3
640 GOTO 600
650 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
660 RETURN
670 '
680 N1=1:FOR I=1 TO JF
690 IF NC(I,1)=2 THEN 700 ELSE 730
700 NC(I,1)=N1:NC(I,2)=N1+1:NC(I,3)=N1+2
710 N1=N1+3:NC(I+1,1)=NC(I,1):NC(I+1,2)=N1:NC(I+1,3)=N1+1:N1=N1+2
720 I=I+1:GOTO 770
730 FOR J=1 TO 3
740 IF NC(I,J)=0 THEN 760  
750 NC(I,J)=N1:N1=N1+1
760 NEXT J
770 NEXT I
780 N1=N1-1
790 PRINT "THERE AREA ";N1;" EQUATIONS"
800 PRINT:PRINT "CODE NUMBERS":PRINT "JOINT  Z   P(X)  P(Y)"
810 FOR I=1 TO JF
820 PRINT USING "###  ";I,NC(I,1),NC(I,2),NC(I,3)
830 NEXT
840 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
850 IB=0:PRINT:PRINT "CALCULATE BAND WIDTH"
860 FOR M1=1 TO M2
870 JN=MJ(M1,1):JM=MJ(M1,2):IR(1)=NC(JN,1)
880 IR(2)=NC(JN,2):IR(3)=NC(JN,3):IR(4)=NC(JM,1)
890 IR(5)=NC(JM,2):IR(6)=NC(JM,3)
900 MI=1000:MA=0
910 FOR I=1 TO 6
920 IF IR(I)=0 THEN 950  
930 IF IR(I)>MA THEN MA=IR(I)
940 IF IR(I)<MI THEN MI=IR(I)
950 NEXT I
960 IC=MA-MI+1
970 PRINT IC;
980 IF IC>IB THEN IB=IC
990 NEXT M1
1000 PRINT:PRINT "BAND WITH = ";IB
1010 DIM S(N1,IB),F(N1),D1(N1)
1020 RETURN
1030 '
1040 PRINT:PRINT"GRID DATA ":PRINT
1050 PRINT "JOINT COORDINATES ": PRINT "JOINT     X         Y"
1060 FOR I=1 TO JF:READ II,CA,CB:CJ(I,1)=CA:CJ(I,2)=CB
1070 PRINT USING "##  #,###.##   #,###.##"; I;CA;CB
1080 NEXT I
1090 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
1100 RETURN
1110 '
1120 ' Dimensions
1130 JN=MJ(M1,1):JM=MJ(M1,2):X=CJ(JM,1)-CJ(JN,1)
1140 Y=CJ(JM,2)-CJ(JN,2):AL=SQR(X*X+Y*Y):AL(M1)=AL
1150 AI=A(M1,1):T=A(M1,2)
1160 IR(1)=NC(JN,1):IR(2)=NC(JN,2):IR(3)=NC(JN,3)
1170 IR(4)=NC(JM,1):IR(5)=NC(JM,2):IR(6)=NC(JM,3)
1180 RETURN
1190 '
1200 FOR I=1 TO N1:F(I)=0:NEXT
1210 FOR I=1 TO M2:W(I)=0:NEXT
1220 READ NL,A$,JL,MU
1230 PRINT
1240 PRINT "LOAD CASE NUMBER ";NL
1250 PRINT "DESCRIPTION - ";A$
1260 PRINT "NO. OF JOINT LOADS = ";JL
1270 PRINT "NUMBER OF MEMBERS WITH UNIFORM LOADS = ";MU
1280 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
1290 CLS
1300 IF JL = 0 THEN PRINT "NO JOINT LOADS ": GOTO 1380
1310 PRINT:PRINT "JOINT LOADS":PRINT
1320 PRINT "JOINT    VERTICAL   MOM. X AXIS  MOM. Y AXIS"
1330 FOR J=1 TO JL
1340 READ IR,P,XM,XT
1350 PRINT USING "####   ##,###.##   ##,###.##    ##,###.##";IR,P,XM,XT
1360 F(NC(IR,1))=P:F(NC(IR,2))=XM:F(NC(IR,3))=XT
1370 NEXT J
1380 IF MU=0 THEN 1600
1390 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
1400 PRINT:PRINT "MEMBER UNIFORM LOADS":PRINT
1410 PRINT "MEMBER      LOAD"
1420 FOR I=1 TO M2:W(I)=0:NEXT
1430 FOR I= 1 TO MU
1440 READ M,W1:PRINT USING "####   ##,####.##";M,W1
1450 W(M)=W1
1460 NEXT I
1470 FOR I=1 TO M2:P=0:R1=0:AM=W(I)*AL(I)^2/12:R1=W(I)*AL(I)/2
1480 JN=MJ(I,1):JM=MJ(I,2)
1490 X=CJ(JM,1)-CJ(JN,1):Y=CJ(JM,2)-CJ(JN,2)
1500 IR(1)=NC(JN,1):IR(2)=NC(JN,2):IR(3)=NC(JN,3)
1510 IR(4)=NC(JM,1):IR(5)=NC(JM,2):IR(6)=NC(JM,3)
1520 AL=SQR(X^2+Y^2)
1530 F(IR(1))=F(IR(1))+R1
1540 F(IR(4))=F(IR(4))+R1
1550 F(IR(2))=F(IR(2))-AM*Y/AL
1560 F(IR(3))=F(IR(3))+AM*X/AL
1570 F(IR(5))=F(IR(5))+AM*Y/AL
1580 F(IR(6))=F(IR(6))-AM*X/AL
1590 NEXT I
1600 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
1610 PRINT:PRINT "LOAD SUMMARY BY JOINTS"
1620 PRINT "JOINT         P           MX           MY"
1630 F(0)=0
1640 FOR I=1 TO JF
1650 IF NC(I,1)=NC(I-1,1) AND NC(I,1) <> 0 THEN 1700
1660 PRINT USING "###  ";I;
1670 FOR J=1 TO 3
1680 PRINT USING "#,###,###.## ";F(NC(I,J));
1690 NEXT J:PRINT
1700 NEXT I
1710 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
1720 FOR I=1 TO N1:D1(I)=F(I):NEXT
1730 RETURN
1740 '
1750 PRINT:PRINT:PRINT "DEFLECTIONS "
1760 PRINT "JOINT    VERTICAL   BEND. ROT.   TORSIONAL ROT."
1770 D1(0)=0
1780 FOR I=1 TO JF:PRINT USING "### ";I;:FOR J=1 TO 3
1790 PRINT USING "###,###.#### ";D1(NC(I,J))/EL;
1800 NEXT J:PRINT:NEXT I
1810 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
1820 RETURN
1830 '
1840 ' FORCES
1850 FOR I=1 TO 6:F1(I)=0:NEXT I
1860 FOR I=1 TO 6:F1(I)=D1(IR(I)):NEXT
1870 FOR II=1 TO 6:S2(II)=0
1880 FOR J=1 TO 6:S2(II)=S2(II)+S1(II,J)*F1(J)
1890 NEXT J
1900 NEXT II
1910 F3=S2(2)*DM-S2(3)*DL
1920 F4=-S2(2)*DL-S2(3)*DM
1930 F5=-S2(5)*DM+S2(6)*DL
1940 F6=S2(5)*DL-S2(6)*DM
1950 SL=-S2(1)+W(M2)*AL/2:SR=SL-W(M2)*AL
1960 PRINT USING "MEMBER NO. ##   JOINT NEAR = ##    FAR = ##";M1,MJ(M1,1),MJ(M1,2)
1970 PRINT "   TORSION       SH.NEAR      SH.FAR     MOM.NEAR    MOM.CENT.   MOM.FAR"
1980 PRINT USING " ###,####.## ";F4,SL,SR;
1990 P=W(M1)*AL^2/12:P7=F3+P:P8=F5+P:PC=+(P7+P8)/2+P*3/2
2000 PRINT USING " ###,###.## ";P7,PC,P8
2010 FOR I=1 TO 6:F(IR(I))=F(IR(I))-S2(I):NEXT
2020 PRINT:IF INT(M1/5)=M1/5 THEN INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
2030 RETURN
2040 '
2050 INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
2060 PRINT "STATICS CHECK BY CODE NUMBERS, VALUES SHOULD BE VERY SMALL"
2070 FOR I=1 TO N1:PRINT USING "###  ##.#### ";I,F(I);
2080 IF INT(I/5)=I/5 THEN PRINT
2090 NEXT:PRINT
2100 PRINT:INPUT "<ENTER> TO CONTINUE ";ZZ:CLS
2110 RETURN
2120 '
2130 ' Subroutine for stiffness
2140 DL=X/AL:DM=Y/AL
2150 A=4*AI/AL:B=A/2:C=6*AI/AL/AL
2160 D=12*AI/AL^3:TA=.4*T/AL
2170 F=D:G=C*DM:H=-C*DL
2180 P= A*DM*DM+TA*DL*DL
2190 Q=-A*DL*DM+TA*DL*DM
2200 R= A*DL*DL+TA*DM*DM
2210 S= B*DM*DM-TA*DL*DL
2220 T=-B*DL*DM-TA*DL*DM
2230 U= B*DL*DL-TA*DM*DM
2240 S1(1,1)= F:S1(1,2)= G:S1(1,3)= H
2250 S1(1,4)=-F:S1(1,5)= G:S1(1,6)= H
2260 S1(2,1)= G:S1(2,2)= P:S1(2,3)= Q
2270 S1(2,4)=-G:S1(2,5)= S:S1(2,6)= T
2280 S1(3,1)= H:S1(3,2)= Q:S1(3,3)= R
2290 S1(3,4)=-H:S1(3,5)= T:S1(3,6)= U
2300 S1(4,1)=-F:S1(4,2)=-G:S1(4,3)=-H
2310 S1(4,4)= F:S1(4,5)=-G:S1(4,6)=-H
2320 S1(5,1)= G:S1(5,2)= S:S1(5,3)= T
2330 S1(5,4)=-G:S1(5,5)= P:S1(5,6)= Q
2340 S1(6,1)= H:S1(6,2)= T:S1(6,3)= U
2350 S1(6,4)=-H:S1(6,5)= Q:S1(6,6)= R
2360 RETURN
2370 '
2380 ' Assembly
2390 FOR IC=1 TO 6
2400 IF IR(IC)=0 THEN 2490 
2410 K=IR(IC)
2420 FOR J=1 TO 6
2430 IF IR(J)=0 THEN 2480 
2440 L=IR(J)
2450 IF (K-L)>0 THEN 2480 
2460 L1=L-K+1
2470 S(K,L1)=S(K,L1)+S1(IC,J)
2480 NEXT J
2490 NEXT IC
2500 RETURN
2510 '
2520 PRINT:' First part of solver
2530 FOR N=1 TO N1
2540 FOR LL=2 TO IB
2550 C=S(N,LL)/S(N,1)
2560 I=N+LL-1
2570 IF (N1-I)<0 THEN 2650 
2580 J=0
2590 FOR K=LL TO IB
2600 J=J+1
2610 S(I,J)=S(I,J)-C*S(N,K)
2620 NEXT K
2630 S(N,LL)=C
2640 NEXT LL
2650 NEXT N
2660 RETURN
2670 '
2680 '  Second part of solver
2690 FOR N=1 TO N1
2700 FOR LL=2 TO IB
2710 I=N+LL-1
2720 IF (N1-I)<0 THEN 2750 
2730 D1(I)=D1(I)-S(N,LL)*D1(N)
2740 NEXT LL
2750 D1(N)=D1(N)/S(N,1)
2760 NEXT N:PRINT
2770 N=N1
2780 N=N-1
2790 IF (N)=0 THEN 2860 
2800 FOR K=2 TO IB
2810 LL=N+K-1
2820 IF(N1-LL)<0 THEN 2840 
2830 D1(N)=D1(N)-S(N,K)*D1(LL)
2840 NEXT K
2850 GOTO 2780 
2860 RETURN
2870 '
3000 DATA LAMELLA FLOOR SYSTEM
3010 ' No. of members, No. o joints, Value of E
3020 DATA 12,11,1600000
3030 DATA 1,0,144, 2,72,0, 3,72,72, 4,72,144, 5,72,216, 6,72,288
3040 DATA 7,144,72, 8,144,144, 9,144,216, 10,216,72, 11,216,216
3050 ' Member properties, No., I value, J value (zero to exit).
3060 DATA 1,760,0.1, 0
3070 ' Member incidences
3080 DATA 1,2,3,1, 2,3,4,1, 3,4,5,1, 4,5,6,1, 5,7,8,1, 6,8,9,1
3090 DATA 7,3,7,1, 8,7,10,1, 9,1,4,1, 10,4,8,1, 11,5,9,1, 12,9,11,1
3100 ' Supports and releases, Jt., vert, Mx, My (zero to exit).
3110 DATA 1,0,1,1, 2,0,1,1, 6,0,1,1, 10,0,1,1, 11,0,1,1, 0
3120 ' Load numb., Descrip., No. joint loads, No. member loads
3130 DATA 1,UNIFORM LOADS, 0,12
3140 ' Two uniform loads
3150 DATA 1,18, 2,33, 3,33, 4,18, 5,33, 6,33, 7,18, 8,18
3160 DATA 9,13, 10,13, 11,18, 12,18
3170 '
4000 DATA SIMPLE EXAMPLE PROBLEM, 2,3,1000
4010 ' Joint coordinates, Jt., X, Y.
4020 DATA 1,0,2, 2,8,8, 3,14,0.
4030 ' Member properties, No., I value, J value (zero to exit).
4040 DATA 1,1,1, 0
4050 ' Member incidences
4060 DATA 1,1,2,1, 2,2,3,1
4070 ' Supports and releases, Jt., vert, Mx, My (zero to exit).
4080 DATA 1,0,0,0, 3,0,0,0, 0
4090 ' Load numb., Descrip., No. joint loads, No. member loads
4100 DATA 1,UNIFORM LOADS, 0,2
4110 ' Two uniform loads
4120 DATA 1,1, 2,1
4130 ' One joint load, down: Jt., P, Mx, My.
4140 DATA 2,JOINT LOAD, 1,0, 2,10,0,0.
4150 '
5000 DATA ILLUSTRATES A HINGE AT JOINTS 2 AND 3 , 2,4,1000
5010 DATA 1,0,2, 2,8,8, 3,8,8, 4,14,0: ' Joint coordinates, Jt., X, Y.
5020 DATA 1,1,1, 0:  ' Member properties, No., I value, J value (zero to exit).
5030 DATA 1,1,2,1, 2,3,4,1: ' Member incidences
5040 ' Supports and releases, Jt., vert, Mx, My (zero to exit).
5050 ' For hinge have two numbers and call the joint by a 2.
5060 DATA 1,0,0,0, 2,2,1,1, 4,0,0,0, 0
5070 DATA 1,UNIFORM LOADS, 0,2, 1,1, 2,1: ' Two uniform loads
5080 DATA 2,JOINT LOAD, 1,0, 2,10,0,0: ' One joint load, down: Jt., P, Mx, My.
